require "defines" -- has a bunch of defined constants for events and inventory, etc. the file itself is data\core\lualib\defines.lua

game.onload(function()
	if glob.harvesters == nil then
		glob.harvesterCount = 0
		glob.harvesters = {}
		glob.harvesterRecipes = {}
		glob.inHarvester = nil
	end
end)

game.onevent(defines.events.onbuiltentity, function(event)
	if glob.harvesters == nil then
		game.showmessagedialog("Something is wrong with the glob table.")
		glob.harvesterCount = 0
		glob.harvesters = {}
		glob.harvesterRecipes = {}
		glob.inHarvester = nil
	end
	if event.createdentity.name == "harvester" then
		glob.harvesterCount = glob.harvesterCount + 1
		glob.harvesters[glob.harvesterCount] = {event.createdentity, glob.harvesterCount}
		glob.harvesterRecipes[glob.harvesterCount] = {}
		--game.showmessagedialog("New harvester instance. HarvesterCount: " .. glob.harvesterCount)
	end
end)

game.onevent(defines.events.ontick, function() --tell game we want to do stuff every tick (60 times per second)
	if glob.harvesters == nil then
		glob.harvesterCount = 0
		glob.harvesters = {}
		glob.harvesterRecipes = {}
		glob.inHarvester = nil
	end

	if game.tick % 2 == 0 then
		if game.player.vehicle and game.player.vehicle.name == "harvester" then

			existingVehicle = nil
			for k, v in pairs(glob.harvesters) do
				if v[1].equals(game.player.vehicle) then
					existingVehicle = v
					break
				end
			end

			-- We just entered a vehicle not tracked.
			if existingVehicle == nil then
				glob.harvesterCount = glob.harvesterCount + 1
				glob.harvesters[glob.harvesterCount] = {game.player.vehicle, glob.harvesterCount}
				glob.harvesterRecipes[glob.harvesterCount] = {}
				existingVehicle = glob.harvesters[glob.harvesterCount]
			end

			--game.showmessagedialog("InHarv " .. tostring(glob.inHarvester == nil))
			if glob.inHarvester == nil then
				onEnterVehicle(existingVehicle)
			end
			glob.inHarvester = existingVehicle
		else
			--game.showmessagedialog("OutHarv " .. tostring(glob.inHarvester == nil))
			if glob.inHarvester ~= nil then
				onLeaveVehicle(glob.inHarvester)
			end
			glob.inHarvester = nil
		end
	end

	if game.tick % 60 == 0 then -- do this only once per second, you can decrease 60 if needed...but it'd probably be better to increase the amount of ore being removed
		if game.player.vehicle and game.player.vehicle.name == "harvester" then -- if the player is in a vehicle and it is a harvester
			onActiveVehicleUpdate()
		end

		for i = 1, glob.harvesterCount do
			if (glob.harvesters[i]) and (glob.harvesters[i][1]) and (not glob.harvesters[i][1].valid) then
				glob.harvesters[i] = nil
			end
		end
	end

	if game.tick % 60 == 0 then
		--game.showmessagedialog("Iterating inactive harvesters: " .. glob.harvesterCount)
		for k, v in pairs(glob.harvesters) do
			if v ~= nil then
				--game.showmessagedialog("Valid harvester instance found.")
				if game.player.vehicle == nil or (not v[1].equals(game.player.vehicle)) then
					onInactiveVehicleUpdate(v)
				end
			end
		end
	end
end) -- end anonymous function and onevent/ontick call5

function onEnterVehicle(vehicle)
end

function onLeaveVehicle(vehicle)
	--game.showmessagedialog("onLeaveVehicle")
	glob.harvesterRecipes[vehicle[2]] = {}
	for k, v in pairs(vehicle[1].getinventory(defines.inventory.playermain).getcontents()) do
		--game.showmessagedialog("recipe: " .. k)
		glob.harvesterRecipes[vehicle[2]][k] = k
	end
	--game.showmessagedialog(serpent.block(glob.harvesterRecipes))
	--game.showmessagedialog(serpent.block(glob.harvesterRecipes[vehicle[2]]))
end

function getBoundingBox(position, radius)
	return {{position.x - radius, position.y-radius}, {position.x + radius, position.y + radius}}
end

function getStackSize(itemName, inactive)
	local maxItemCount = 64
	if itemName == "diesel-locomotive" then
		maxItemCount = 8
	end
	if itemName == "cargo-wagon" then
		maxItemCount = 8
	end
	if itemName == "car" then
		maxItemCount = 1
	end
	if itemName == "harvester" then
		maxItemCount = 0
	end
	if itemName == "lab" then
		maxItemCount = 8
	end
	if itemName == "train-stop" then
		maxItemCount = 8
	end
	if itemName == "rocket-defense" then
		maxItemCount = 4
	end
	if itemName == "roboport" then
		maxItemCount = 4
	end
	if itemName == "blueprint" then
		maxItemCount = 1
	end
	if itemName == "deconstruction-planner" then
		maxItemCount = 1
	end
	if itemName == "basic-beacon" then
		maxItemCount = 8
	end
	if itemName == "oil-refinery" then
		maxItemCount = 8
	end
	if itemName == "chemical-plant" then
		maxItemCount = 8
	end
	if itemName == "alien-artifact" then
		if inactive then
			maxItemCount = 64
		else
			maxItemCount = 0
		end
	end
	return maxItemCount
end

function onInactiveVehicleUpdate(vehicle)
	local trunkInv = vehicle[1].getinventory(defines.inventory.playermain)
	-- We don't need alien artifact for this?
	--if trunkInv.getitemcount("alien-artifact") > 0 then
		--game.showmessagedialog(serpent.block(quickbar.getcontents()))
		--game.showmessagedialog("onInactiveVehicleUpdate: Start checking recipes.")
		if glob.harvesterRecipes[vehicle[2]] == nil then
			--game.showmessagedialog("onInactiveVehicleUpdate: this harv doesn't have recipe.")
			onLeaveVehicle(vehicle)
		end
		--game.showmessagedialog(serpent.block(glob.harvesterRecipes[vehicle[2]]))
		for k, v in pairs(glob.harvesterRecipes[vehicle[2]]) do
			--game.showmessagedialog("Recipe: " .. v .. " *" .. trunkInv.getitemcount(v) .. " / " .. getStackSize(v))
			if trunkInv.getitemcount(v) < getStackSize(v) then
				if trunkInv.caninsert({name=v, count="1"}) then
					trunkInv.insert({name=v, count="1"})
				end
			end
		end
	--end
end

function onActiveVehicleUpdate()
	local ore = game.findentitiesfiltered{type = "resource", area=getBoundingBox(game.player.vehicle.position, 2)} -- get a table of the ore within a (square) radius of 10 around the harvester, thankfully that was fairly easy, change the '10' to any value you think is appropriate, the 'type = "resource"' might allow it to 'mine' trees as well...if so and you didn't want that you'd need to have multiple tables and instead search using 'name = "name_of_ores"'
	local oreAmount = 2 -- amount of ore to mine from each resource spot
	if #ore > 0 then
		for _, ore in ipairs(ore) do -- loop through those ores
			if ore.name ~= "crude-oil" and ore.name:sub(-4) ~= "tree" then
				if game.player.vehicle.caninsert{name = ore.name, count = oreAmount} then -- if the harvester is not full
					if ore.amount >= oreAmount then -- if there is more than enough ore
						ore.amount = ore.amount - oreAmount * 0.1 -- decrement the ore by oreAmount
						game.player.vehicle.insert{name = ore.name, count = oreAmount} -- and insert it into the harvester
					else -- if the amount of ore left is not greater than or equal to what we want to remove, just remove all of it (without the else, it'd leave any spots less than oreAmount...which would be somewhat annoying lol)
						game.player.vehicle.insert{name = ore.name, count = ore.amount} -- insert first so that we don't need a local variable to store the amount
						ore.amount = 99 -- then just set ore amount to 0 instead doing ore.amount = ore.amount - ore.amount (cause that looks silly :))
					end
				end
			end
		end
	else
		-- Auto-cloning objects in quickbar
		local quickbar = game.player.getinventory(defines.inventory.playerquickbar)
		local trunkInv = game.player.vehicle.getinventory(defines.inventory.playermain)
		if quickbar.getitemcount("alien-artifact") > 0 then
			--game.showmessagedialog(serpent.block(quickbar.getcontents()))
			for itemName, itemCount in pairs(quickbar.getcontents()) do
				--game.showmessagedialog(itemName .. " " .. itemCount)
				if trunkInv.getitemcount(itemName) < getStackSize(itemName) then
					if trunkInv.caninsert({name=itemName, count="1"}) then
						trunkInv.insert({name=itemName, count="1"})
					end
				end
			end
		end
	end

	--auto coal placement into burner from trunk
	if game.player.vehicle and game.player.vehicle.name == "harvester" then
		local burnerCoal = game.player.vehicle.getinventory(1)
		local trunkCoal = game.player.vehicle.getinventory(2)
		-- notice that I combined these since you won't do anything if only one is true
		if burnerCoal.getitemcount() <= 19 and trunkCoal.getitemcount("coal") > 0  then
			trunkCoal.remove({name="coal", count="1"})
			burnerCoal.insert({name="coal", count="1"})
		end
	end
end
